#include "stdafx.h"

#include "john.h"

void WriteParamLog(	CString sFileName,	
					unsigned long m_ProcessID,				// vZXID
					unsigned long m_ulRealStartAddress,		// vZX̊ƂȂx[XJnAhX
					unsigned long m_ulVirtualStartAddress,	// emuhastẽwLTr[̊JnAhX
					unsigned long m_ulCodeCount,			// ͂ꂽR[h̐
					unsigned long m_ulWriteAddress[],		// R[h̃AhXz
					unsigned long m_ulWriteParam[],			// R[h̃p[^z
					unsigned char m_ucAdvancedCheck)		// DLLg`FbN̒l(`FbN=1)
{
	CString sLog;

	sLog.Format(_T("%08X, %08X, %08X, %ld, %d\n"), 
		m_ProcessID, 
		m_ulRealStartAddress, 
		m_ulVirtualStartAddress, 
		m_ulCodeCount, 
		(int)m_ucAdvancedCheck);

	WriteLog(sFileName, sLog);

	for (unsigned long i = 0; i < m_ulCodeCount; i ++) {
		sLog.Format(_T("%02d,%08X,%08X\n"), i, m_ulWriteAddress[i], m_ulWriteParam[i]);
		WriteLog(sFileName, sLog);
	}

	WriteNewLine(sFileName);
}

BOOL WriteLog(CString sFileName, CString sLog)
{
	CTime	tm = CTime::GetCurrentTime();
	CString sDateTime;
	FILE*	fp;

	sDateTime.Format(_T("%04d/%02d/%02d %02d:%02d:%02d "),
		tm.GetYear(),
		tm.GetMonth(),
		tm.GetDay(),
		tm.GetHour(),
		tm.GetMinute(),
		tm.GetSecond());

	if (NULL == (fp = _tfopen(sFileName, _T("at")))) {
		return FALSE;
	}

	_fputts(LPCTSTR(sDateTime), fp);
	_fputts(LPCTSTR(sLog), fp);
	
	fclose(fp);

	return TRUE;
}

BOOL WriteNewLine(CString sFileName)
{
	FILE*	fp;

	if (NULL == (fp = _tfopen(sFileName, _T("at")))) {
		return FALSE;
	}

	_fputts(_T("\n"), fp);
	
	fclose(fp);

	return TRUE;
}
